## Assign treatment
#source('gen_control.R')

## Load control dataset
load('controlpool.RData')

controlpool[controlpool!=0] = controlpool[controlpool!=0] + 
				rnorm(sum(controlpool!=0), 0, .5)

while(1){
	gencontrol = controlpool[,sample(1:ncol(controlpool), 100, replace=TRUE)]
	Y0 = gencontrol

	## Find clusters and get trt id for each cluster
	cls = kmeans(t(Y0==0), 3)
	if(min(cls$size) > 10)
		break;
}

cls = cls$cluster
trtid = c(sample(cls[cls==1])[1],
			sample(cls[cls==2])[1], sample(cls[cls==3])[1])
trtid = names(trtid)
trtid = sapply(trtid, function(x) which(colnames(Y0)==x))

if(!hetero){
	Y0 = rbind(Y0, Y0[1,]-Y0[1,]+Y0[10,], 
			Y0[2,]-Y0[1,]+Y0[10,], Y0[3,]-Y0[1,]+Y0[10,])

	T0 = 10
	T = 13

	Y0 = t(Y0)
	Y = Y0

	stickytimes = list()
	stickytimes[[1]] = which(Y[trtid[1],T0+1:3]==0)
	stickytimes[[2]] = which(Y[trtid[2],T0+1:3]==0)
	stickytimes[[3]] = which(Y[trtid[3],T0+1:3]==0)


	Y[trtid[1],setdiff((T0+1):T, stickytimes[[1]])] = Y[trtid[1],setdiff((T0+1):T, stickytimes[[1]])]*(c(.9, .7, .8)[setdiff((T0+1):T, stickytimes[[1]])-T0])
	Y[trtid[2],setdiff((T0+1):T, stickytimes[[2]])] = Y[trtid[1],setdiff((T0+1):T, stickytimes[[1]])]*(c(.95, .75, .85)[setdiff((T0+1):T, stickytimes[[1]])-T0])
	Y[trtid[3],setdiff((T0+1):T, stickytimes[[3]])] = Y[trtid[1],setdiff((T0+1):T, stickytimes[[1]])]*(c(1, 1, 1)[setdiff((T0+1):T, stickytimes[[1]])-T0])
}

if(hetero){

	Y0 = rbind(Y0, sqrt(Y0[1,]*Y0[4,]), 
			sqrt(Y0[2,]*Y0[5,]), sqrt(Y0[3,]*Y0[6,]))

	T0 = 10
	T = 13
		
	Y0 = t(Y0)
	Y = Y0

	stickytimes = list()
	stickytimes[[1]] = which(Y[trtid[1],T0+1:3]==0)
	stickytimes[[2]] = which(Y[trtid[2],T0+1:3]==0)
	stickytimes[[3]] = which(Y[trtid[3],T0+1:3]==0)


	## True parameter
	est0 = cbind(Y[trtid[1], (T0+1):T] - Y0[trtid[1], (T0+1):T],
			Y[trtid[2], (T0+1):T] - Y0[trtid[2], (T0+1):T],
			Y[trtid[3], (T0+1):T] - Y0[trtid[3], (T0+1):T])

}

