## RMSE comparison for different lambada values
lambdacv = lambda

res_propsclambda = NULL

lambdaseq = c(lambdacv*.1, lambdacv*.2, lambdacv*.25, lambdacv*.5, lambdacv*.75, 1.25*lambdacv, 
				lambdacv*1.5, lambdacv*2, lambdacv*2.5, lambdacv*3)
for(lambda in lambdaseq){

	res1 = res

	for(i in 1:N1){
		X1i = matrix(X1[,i],ncol=1)
			
		X0i = t(X0_int[,,drop=FALSE])
		zeros = which(X1i==0)
		if(length(zeros ) >0)
			res1$qvecfull[(i-1)*N0_int+(1:N0_int)] = res1$qvecfull[(i-1)*N0_int+(1:N0_int)] + 
				apply(X0i, 1, function(x) sum(exp(lambda*x[zeros])))
		#print(round(c(i, apply(X0i, 1, function(x) sum(exp(lambda*x[zeros]/1000)))/100), 2))
	}

	Pmataggregated = res1$Pmatfull*(1-nu) + res1$Pmatpooled*nu
	qvecaggregated = res1$qvecfull*(1-nu) + res1$qvecpooled*nu

	## Constraints
	i_sm <- NULL
	j_sm <- NULL
	for(i in 1:N1){
		i_sm = c(i_sm, rep(i, N0))
		j_sm = c(j_sm, 1:N0)
	}
	for(i in 1:N1){
		i_sm = c(i_sm, N1+(i-1)*N0+(1:N0))
		j_sm = c(j_sm, (i-1)*N0_int+(1:N0))
	}
	Afinal1 = Matrix::sparseMatrix(i=i_sm, j=j_sm, x=1, dims=c(N1+N1*N0, N1*N0_int))
	gc()

	## Optimization to find synthetic control weights
	sol <- osqp::solve_osqp(P = Pmataggregated, q = qvecaggregated,
				A = Afinal1, l = l, u = u, pars = settings)

	wmat = matrix(sol$x, ncol=N0_int, byrow=TRUE)
	dim(wmat)

	q_sep = mean(sapply(1:N1, function(i) 
				mean( (X1[,i] - sol$x[(i-1)*N0_int+(1:N0_int)]%*%t(X0_int[,,drop=FALSE]))^2 ) ))
	#q_sep

	X0_all = as.matrix(t(Y[-trtid,]))
	X0_all_int = cbind(t(Y[-trtid,]), 1)

	## Imbalance
	imb = t(Y[trtid,1:T0]) - sapply(1:N1, function(i)
		sol$x[(i-1)*N0_int+(1:N0_int)]%*%t(X0_all_int[1:T0,,drop=FALSE]))
	## Estimate
	est = t(Y[trtid,(T0+1):T]) - sapply(1:N1, function(i)
		sol$x[(i-1)*N0_int+(1:N0_int)]%*%t(X0_all_int[(T0+1):T,,drop=FALSE]))


	l2imb_propsc = mean(apply(imb, 2, function(x) sqrt(mean(x^2))))

	## RMSE calculation
	esterr = est - est0
	rmseitt_propsc = mean(apply(esterr, 2, function(x) sqrt(mean(x^2))))
	rmseatt_propsc = sqrt(mean(colMeans(esterr)^2))

	res_propsclambda =c(res_propsclambda, c(l2imb_propsc, rmseitt_propsc, rmseatt_propsc))

}