## Implementation of the proposed method with L1 penalty
## called by compare_methods_l1penalty_largesd.R
## Setup 
X1 = t(Y[trtid,1:T0]) #as.matrix(d_trt_b[1:10,])
X0 = t(Y[-trtid,1:T0])

N1 = ncol(X1)
N0 = ncol(X0)
X0_int = cbind(X0, 1)
N0_int = ncol(X0_int)

#########################################################################################

## Create the Pmat and qvec for our optimization
## X1 is treated units data matrix, pretreatment
## X0 is control units data matrix, pretreatment

getPmatqvec <- function(X0, X1){

	N1 = ncol(X1)
	X0 = cbind(X0, 1)
	N0 = ncol(X0)
	T = nrow(X1)

	## Separate and no lambda
	qvecfull = NULL
	Pmat = list()
	for(i in 1:ncol(X1)){

		X1i = matrix(X1[,i],ncol=1)
			
		X0i = t(X0[,,drop=FALSE])

		Pmat[[i]] <- X0i %*% t(X0i)
		qvecfull <- c(qvecfull, - t(X1i) %*% t(X0i))
	}

	Pmatfull = Matrix::bdiag(Pmat)


	## Pooled

	qvecpooled <- rep(NA, length(qvecfull))
	for(j in 1:ncol(X0))
		qvecpooled[seq(j,length(qvecpooled), by=N0)] =  
				- mean(sapply(1:T, function(s) sum(X1[s,])*X0[s,j]))
	temp = 0
	for(s in 1:T)
		temp = temp+outer(as.numeric(X0[s,]),as.numeric(X0[s,]))
	temp = temp/T
	dim(temp)
	
	Pmatpooled = matrix(NA, N1*N0, N1*N0)
	for(i in 1:N1)
		for(i1 in 1:N1)
			Pmatpooled[(i-1)*N0+(1:N0),(i1-1)*N0+(1:N0)] = temp


	return(list(Pmatfull =Pmatfull, qvecfull=qvecfull, Pmatpooled=Pmatpooled, qvecpooled =qvecpooled))

}

res = getPmatqvec(X0, X1)
#############################################

## Add L1 constraint

i_sm <- NULL
j_sm <- NULL
for(i in 1:N1){
	i_sm = c(i_sm, rep(i, N0))
	j_sm = c(j_sm, N0_int*(i-1)+(1:N0))
}
for(i in 1:N1){
	i_sm = c(i_sm, N1+(i-1)*N0+(1:N0))
	j_sm = c(j_sm, (i-1)*N0_int+(1:N0))
}




x_sm = rep(1, length(i_sm))
len_x_sm = length(x_sm)
length(i_sm) == length(x_sm)


for(i in 1:N1){
	for(tm in 1:T0){
		i_sm = c(i_sm, len_x_sm + (i-1)*T0+(tm-1)+rep(i, N0_int))
		j_sm = c(j_sm, N0_int*(i-1)+(1:N0_int))

		x_sm = c(x_sm, X0_int[tm,] - X1[tm, i])

		if(length(i_sm)!=length(x_sm)){
			print('No')
			break;
		}
	}
}


#############################################
## setup constraints 

Afinal1 = Matrix::sparseMatrix(i=i_sm, j=j_sm, x=x_sm, dims=c(max(i_sm), N1*N0_int))



l <- c(rep(1,N1), numeric(N1*N0))
u <- c(rep(1,N1), rep(1, N1*N0))
l = c(l, rep(-1*pen, nrow(Afinal1) - length(l)) )
u = c(u, rep(pen, nrow(Afinal1) - length(u)) )

#############################################
## Run convex optimization
settings = osqp::osqpSettings(verbose = FALSE, eps_rel = 1e-8, eps_abs = 1e-8)

sol <- try( osqp::solve_osqp(P = res$Pmatfull, q = res$qvecfull,
			A = Afinal1, l = l, u = u, pars = settings) , silent = TRUE)
			

#############################################
## Estimation and rmse calculation
X0_all = as.matrix(t(Y[-trtid,]))
X0_all_int = cbind(t(Y[-trtid,]), 1)

imb = t(Y[trtid,1:T0]) - sapply(1:N1, function(i)
	sol$x[(i-1)*N0_int+(1:N0_int)]%*%t(X0_all_int[1:T0,,drop=FALSE]))
est = t(Y[trtid,(T0+1):T]) - sapply(1:N1, function(i)
	sol$x[(i-1)*N0_int+(1:N0_int)]%*%t(X0_all_int[(T0+1):T,,drop=FALSE]))


l2imb_propscl1 = mean(apply(imb, 2, function(x) sqrt(mean(x^2))))

esterr = est - est0
rmseitt_propscl1 = mean(apply(esterr, 2, function(x) sqrt(mean(x^2))))
rmseatt_propscl1 = sqrt(mean(colMeans(esterr)^2))

res_propscl1 =c(l2imb_propscl1, rmseitt_propscl1, rmseatt_propscl1)



