## Called by run_sc_simulation_comparison_lambda1000.R

## generate control potential outcomes
source('3assign_trt.R')

	

## 45 (3k) total units, they are treated at time time T0=45

############################################################################
## Separate synthetic controls
#library(Synth)

imb = NULL
est = NULL
for(setid in 1:3){

sc = deprintize(synth)(X1 = t(Y[trtid[setid],1,drop=FALSE]),
		X0 = t(Y[setdiff(1:nrow(Y), trtid),1,drop=FALSE]),
		Z1 = t(Y[trtid[setid],1:T0,drop=FALSE]), 
		Z0 = t(Y[setdiff(1:nrow(Y), trtid),1:T0,drop=FALSE]))


imb = cbind(imb, as.numeric(t(sc$solution.w)%*%Y[setdiff(1:nrow(Y), trtid),1:T0,drop=FALSE] - 
	Y[trtid[setid],1:T0,drop=FALSE]))
est = cbind(est, as.numeric(Y[trtid[setid],(T0+1):T,drop=FALSE] - t(sc$solution.w)%*%Y[setdiff(1:nrow(Y), trtid),(T0+1):T,drop=FALSE]
	))
}

l2imb_sc = mean(apply(imb, 2, function(x) sqrt(mean(x^2))))

## RMSE calculation

esterr = est - est0
rmseitt_sc = mean(apply(esterr, 2, function(x) sqrt(mean(x^2))))
rmseatt_sc = sqrt(mean(colMeans(esterr)^2))

res_sc = c(l2imb_sc, rmseitt_sc, rmseatt_sc)

print('done')
############################################################################
## Pooled synthetic control
#library('rlang', lib='\\\\ad.ufl.edu\\clas\\home\\b\\bkarmakar\\Documents\\tmp')

#library(augsynth)
N0 = 3*k-3

Ytemp = Y[-trtid,]
dim(Ytemp)
d <- data.frame(id=rep(1:nrow(Ytemp), ncol(Ytemp)), 
		time = rep(1:ncol(Ytemp), each=nrow(Ytemp)), 
		y=as.numeric(Ytemp), tr = 0)

Ytemp = Y[trtid,]
dim(Ytemp)
d1 <- data.frame(id=rep(N0+1:nrow(Ytemp), ncol(Ytemp)), 
		time = rep(1:ncol(Ytemp), each=nrow(Ytemp)), 
		y=as.numeric(Ytemp), tr = 0)
d1[d1$time>T0,'tr'] = 1

d2 <- rbind(d, d1)
d2 <- d2[order(d2$id, d2$time),]

print('done 2')
#View(d2)

## calculation of synthetic control weights
syn <- augsynth::multisynth(form=y ~ tr, unit=id, time=time, data=d2)

## Imbalance calculation and estimation
imb = (t(rbind(Y[trtid,1:T0,drop=FALSE] - t(syn$weights[1:N0,])%*%Y[setdiff(1:nrow(Y), trtid),1:T0,drop=FALSE])))


est = (t(rbind(Y[trtid,(T0+1):T,drop=FALSE] - t(syn$weights[1:N0,])%*%Y[setdiff(1:nrow(Y), trtid),(T0+1):T,drop=FALSE])))


l2imb_pooledsc = mean(apply(imb, 2, function(x) sqrt(mean(x^2))))

## RMSE calculation

esterr = est - est0
rmseitt_pooledsc = mean(apply(esterr, 2, function(x) sqrt(mean(x^2))))
rmseatt_pooledsc = sqrt(mean(colMeans(esterr)^2))

res_pooledsc = c(l2imb_pooledsc, rmseitt_pooledsc, rmseatt_pooledsc)

print('done 3')

############################################################################
## Proposed penalized synthetic control

source('4compare_methods_proposed_lambda1000.R')

print('done 4')

source('5compare_methods_proposed_lambda_cv_lambda1000.R')

