## simulation settings
#	similarclusseq for three clustering models for damping
#		= 2 for deterministically 
#		= 1 for probabilistially similar clusters
#		= 0 for probabilistially dissimilar clustering
## seedseq is used to track parallel run of the code
similarclusseq = c(0, 1, 2)
heteroseq = c(TRUE, FALSE)
seedseq = c(1234, 8041, 1546, 1362, 2315, 2141, 5362, 6163, 2326, 6126)
seedseq = c(seedseq, c(123, 804, 154, 162, 231, 241, 536, 163, 326, 126))
seedseq = c(seedseq, c(13, 84, 54, 62, 31, 41, 53, 63, 36, 26))
#seedseq = c(seedseq, c(3213, 584, 1254, 5363, 6431, 7841, 5573, 2363, 6436, 2726))
#seedseq = c(seedseq, c(8913, 9884, 8954, 9862, 8931, 9841, 8953, 9863, 8936, 9826))

foo <- function(x, y) c(x, y)
setup = outer(similarclusseq, heteroseq, FUN = Vectorize(foo, SIMPLIFY = FALSE))
setup = outer(setup, seedseq, FUN = Vectorize(foo, SIMPLIFY = FALSE))
setup = sapply(setup, cbind)
#####################################
## Read and organize results
res = list()
for(set in 1:6)
	res[[set]] = matrix(0,ncol=13,nrow=0)

for(id in 1:180){
	
	similarclus = setup[1,id] + 1 
	hetero = 1+(setup[2,id]==1)
	set 	= 2*(similarclus-1)+ hetero

	f = 	paste0('sc_sim_comparison_id_',id,'.csv')
	if(file.exists(f))
		res[[set]] = rbind(res[[set]], read.csv(f))

}

#View(t(sapply(res, colMeans))[c(2,4,6),])

round(t(sapply(res, colMeans))[c(2,4,6),-(1:3)],2)

