library('matrixStats')


########################################
## simulation settings
#	similarclusseq for three clustering models for damping
#		= 2 for deterministically 
#		= 1 for probabilistially similar clusters
#		= 0 for probabilistially dissimilar clustering
## seedseq is used to track parallel run of the code
similarclusseq = c(0, 1, 2)
heteroseq = c(TRUE, FALSE)
seedseq = c(1234, 8041, 1546, 1362, 2315, 2141, 5362, 6163, 2326, 6126)
seedseq = c(seedseq, c(123, 804, 154, 162, 231, 241, 536, 163, 326, 126))
seedseq = c(seedseq, c(13, 84, 54, 62, 31, 41, 53, 63, 36, 26))
#seedseq = c(seedseq, c(3213, 584, 1254, 5363, 6431, 7841, 5573, 2363, 6436, 2726))
#seedseq = c(seedseq, c(8913, 9884, 8954, 9862, 8931, 9841, 8953, 9863, 8936, 9826))

foo <- function(x, y) c(x, y)
setup = outer(similarclusseq, heteroseq, FUN = Vectorize(foo, SIMPLIFY = FALSE))
setup = outer(setup, seedseq, FUN = Vectorize(foo, SIMPLIFY = FALSE))
setup = sapply(setup, cbind)
#####################################
## Read and organize results
res = list()
for(set in 1:6)
	res[[set]] = matrix(0,ncol=13,nrow=0)

for(id in 1:180){
	
	similarclus = setup[1,id] + 1 
	hetero = 1+(setup[2,id]==1)
	set 	= 2*(similarclus-1)+ hetero

	f = 	paste0('sc_sim_comparison_id_',id,'_null.csv')
	if(file.exists(f)){
		temp = as.matrix(read.csv(f, header=TRUE))
		names(temp) = NULL
		res[[set]] = rbind(res[[set]], temp)
	}

}


## Create table
res_summary_null = t( rbind(round(t(sapply(res, colMeans))[c(1,3,5),],2), round(t(sapply(res, function(x) apply(x, 2, function(y) sd(y)/sqrt(length(y)))))[c(1,3,5),],2)))

res_summary_null = res_summary_null[-(1:4),]

res_summary_hetero = t( rbind(round(t(sapply(res, colMeans))[c(2,4,6),],2), round(t(sapply(res, function(x) apply(x, 2, function(y) sd(y)/sqrt(length(y)))))[c(2,4,6),],2)))

res_summary_hetero = res_summary_hetero[-(1:4),]

colnames(res_summary_null) = colnames(res_summary_hetero) = 
						c('est prob dissimilar clus',
							'est prob similar clus',
							'est deterministic and diff clus',
							'se prob dissimilar clus',
							'se prob similar clus',
							'se deterministic and diff clus')
rownames(res_summary_null) = rownames(res_summary_hetero) = 
			as.vector(sapply(c('SC', 'PooledSC',
			'PenalizedSC'), paste0, '_',
				c('l2imbalance', 'rmseitt', 'rmseate')))
				
res_summary_null
res_summary_hetero
