args = commandArgs(trailingOnly=TRUE)
id=as.numeric(args)[1]

library(Synth)
library(augsynth)
library(osqp)
library(Matrix)


########################################
## simulation settings
#	similarclusseq for three clustering models for damping
#		= 2 for deterministically 
#		= 1 for probabilistially similar clusters
#		= 0 for probabilistially dissimilar clustering
## seedseq is used to track parallel run of the code

similarclusseq = c(0, 1, 2)
heteroseq = c(TRUE, FALSE)
seedseq = c(1234, 8041, 1546, 1362, 2315, 2141, 5362, 6163, 2326, 6126)
seedseq = c(seedseq, c(123, 804, 154, 162, 231, 241, 536, 163, 326, 126))
seedseq = c(seedseq, c(13, 84, 54, 62, 31, 41, 53, 63, 36, 26))
#seedseq = c(seedseq, c(3213, 584, 1254, 5363, 6431, 7841, 5573, 2363, 6436, 2726))
#seedseq = c(seedseq, c(8913, 9884, 8954, 9862, 8931, 9841, 8953, 9863, 8936, 9826))


foo <- function(x, y) c(x, y)
setup = outer(similarclusseq, heteroseq, FUN = Vectorize(foo, SIMPLIFY = FALSE))
setup = outer(setup, seedseq, FUN = Vectorize(foo, SIMPLIFY = FALSE))
setup = sapply(setup, cbind)

########################################

similarclus = setup[1,id]
hetero = setup[2,id]==1
thisseed = setup[3,id]
set.seed(thisseed)

## dismiss unnecessary printing

deprintize<-function(f){
 return(function(...) {capture.output(w<-f(...));return(w);});
}

options(width = 180)

res_all = NULL
for(itr in 1:15){
	source('compare_methods.R')
	print(c(similarclus, hetero, res_sc, res_pooledsc, res_propsc, res_propsclambda))
	for(i in 1:length(lambdaseq))
		print(round(res_propsclambda[(i-1)*3+1:3]/res_propsc,2))
	res_all = rbind(res_all, c(res_sc, res_pooledsc, res_propsc, res_propsclambda))
}

write.csv(cbind(similarclus, hetero, thisseed, res_all), file = paste0('sc_sim_comparison_id_',id,'_null.csv'))


